
#import "lib/template_common.typ": template_common, work_entry, project, indent, SMALL_STRONG

#let education = indent[
  #work_entry(
    "University of Waterloo",
    "B.A.Sc. in Computer Engineering — 3.7/4.0 GPA",
    start_date: "Sep 2022",
    end_date: "Aug 2026",
    location: "Waterloo, ON",
    tasks: (
      [Courses: Object-oriented programming, data structures & algorithms, digital
        logic & circuits, operating systems],
      [Extracurriculars: Hack the North Organising Team, UW Orbital Satellite Design
        Team],
    ),
  )
]

#let skills = indent[
  *Languages:* Python, C, C++, Rust, Java, MATLAB, HTML/CSS/JavaScript \
  // Dart
  *Technologies:* Qt, PySide2, React, Spring Boot, Express, GraphQL \
  // Qt, Jest / Pytest, Apollo, Prisma, Rails
  *Tools:* Linux, Git, Docker, Quartus, Pytest, Jest, Postgres, AWS/GCP,
  Kubernetes, Terraform // Jenkins, systemd, Jira
]

#show: doc => template_common(education, skills, doc)

= Experience

#indent[
  #work_entry(
    "Software Engineering Intern",
    "Magna",
    company_link: "https://magna.so",
    start_date: "Sep 2024",
    end_date: "Dec 2024",
    location: "New York, NY",
    tools: "Rust, TypeScript, Solidity, React, GraphQL",
    tasks: (
      [Created tooling to automate constructing and deploying new customer landing
        portals based off of Figma designs],
      [Developed a new external REST API for customers who wanted to access their token
        data programmatically], // termination display (FE), external API for customers not using our platform (BE)
      [Wrote and audited smart contracts on the Solana blockchain to add claim fees to
        our token vesting platform],
    ),
  )

  #work_entry(
    "Software Developer",
    "Immigr8",
    company_link: "https://immigr8now.com",
    start_date: "Jan 2024",
    end_date: "Apr 2024",
    location: "Remote",
    tools: "TypeScript, Spring Boot, React, Terraform, AWS",
    tasks: (
      [Owned end-to-end development of a secure document vault for users to upload ID
        documents with S3 and Textract],
      [Championed and shipped features for *SOC 2 security compliance*, including
        *role-based permissions with JWTs* in Spring Boot, alert logging with
        CloudWatch, and strong privacy controls for user data],
      [Fully implemented the Calendly Auth Code OAuth2 flow with automated refresh of
        expired access tokens],
      [Created a parallel *CI/CD system from scratch* with Terraform and Jenkins to
        automatically deploy AWS Lambdas], // BE-infra only, FE ver is admin dashboard
    ),
  )

  #work_entry(
    "Software Engineering Intern",
    "Dropbase",
    company_link: "https://dropbase.io",
    start_date: "May 2023",
    end_date: "Aug 2023",
    location: "Remote",
    tools: "Python, TypeScript, React, AWS",
    tasks: (
      [Shipped an *LSP server for our custom query language*, including user-specific
        autocomplete and syntax highlighting],
      [Architected a data query builder and executor engine for customers to visualise
        their data warehouses by custom-tailoring forms on-the-fly, supporting complex
        nested logic for 3000+ enterprise users across 8 database types], //
      [Developed a serverless microservice to asynchronously ingest email attachments
        directly into ETL pipelines],
      // [??? emphasise test driven development or remove line *Reduced request errors by 30%* by creating backend testing infrastructure with
      //   *Pytest* to catch regressions and test new features across database engines with
      //   *90% code coverage*],
    ),
  )

  #work_entry(
    "Backend / Infrastructure Developer",
    "Hack the North",
    company_link: "https://hackthenorth.com",
    start_date: "Mar 2023",
    end_date: "Oct 2024",
    location: "Waterloo, ON",
    tools: "TypeScript, Express, Postgres, Kubernetes",
    tasks: (
      [Overhauled CI/CD pipelines, speeding up builds by *35%* by parallelising testing
        and type checking],
      [Introduced backend tracing with OpenTelemetry and Grafana to profile performance
        issues in production],
      [*Resolved load spike crashes* in prod by caching queries via *Redis* and
        horizontally scaling services on *Kubernetes*],
    ),
  )
]

= Awards

#indent[
  #set strong(delta: SMALL_STRONG)
  #show link: underline

  - #link("https://devpost.com/software/perdiem")[Winner of the EdTech category] at
    Simon Fraser University's StormHacks 2022 from 388 participants
  - #link(
      "https://devpost.com/software/resketch",
    )[Winner of the IBM Open Source category]
    at YRHacks 2022 for building Resketch
]

= Projects
#set strong(delta: SMALL_STRONG)

#indent[
  // #project(
  //   "Game Boy Advance Emulator",
  //   "Rust, SDL2, Vulkan",
  //   repo_link: "https://github.com/potatoeggy/gbarr",
  //   tasks: (
  //     [Implemented an *ARMv7* emulator for old games to run on modern x86_64 platforms
  //       with *SDL2* and *Vulkan*],
  //     [WebGPU and WASM for portability, typestate to guarantee everything is always
  //       valid],
  //   ),
  // )

  #project(
    "Mandown",
    "Python, Qt",
    repo_link: "https://github.com/potatoeggy/mandown",
    tasks: (
      [Created a CLI and GUI to scrape and convert webcomics into e-ink-optimised files
        with a *plugin-based architecture*],
      [Expanded support for new formats and features #link("https://github.com/potatoeggy/mandown/issues/55")[based on] #link("https://github.com/potatoeggy/mandown/issues/89")[user] #link("https://github.com/potatoeggy/mandown/issues/63")[demand],
        minimising regressions with #link(
          "https://github.com/potatoeggy/mandown/blob/master/tests/test_source_batoto.py",
        )[E2E tests]],
      [Implemented *image caching and multithreading* to increase download and
        processing speeds by *300%*],
    ),
  )

  #project(
    "PNG Crawler",
    "C++",
    tasks: (
      [Developed a web crawler and a custom PNG validator to download and parse PNGs
        from the internet with *libcurl*],
      [Optimised the crawler to download and process images concurrently with *POSIX
        threads* and curl_multi],
    ),
  )

  // #project(
  //   "Kobink",
  //   "Rust, Axum",
  //   repo_link: "https://github.com/potatoeggy/kobink",
  //   tasks: (
  //     [Built a backend to sync custom ebook files to Kobos by reverse-engineering and
  //       mimicking the Kobo Sync API],
  //   ),
  // )

  // #project(
  //   "Kobo Sync Server",
  //   "Rust, Axum",
  //   repo_link: "https://github.com/potatoeggy/kobink",
  //   tasks: (
  //     [Developed a *Rust* backend to sync custom ebook files to Kobos by reimplementing
  //       the Kobo Sync API],
  //     [Deployed the service behind an nginx reverse proxy and Cloudflare DNS to sync
  //       over the internet],
  //   ),
  // )

  // #project(
  //   "Genshin Rewards Simulator",
  //   "Vue, TypeScript",
  //   repo_link: "https://github.com/potatoeggy/primoprod",
  //   demo_link: "https://primoprod.vercel.app",
  //   tasks: (
  //     [Built a realistic and beautiful *loot box simulator* with CSS animations based
  //       off a popular game],
  //     [Reduced action latency by *90%* by lazily loading art assets at opportune times,
  //       such as during cutscenes],
  //   ),
  // )

  // #project(
  //   "Jeopardy!",
  //   "Vue, TypeScript, WebSockets",
  //   repo_link: "https://github.com/potatoeggy/jeopardy",
  //   demo_link: "https://jeopardy.eggworld.me/host",
  //   tasks: (
  //     [Developed a beautiful and polished game where participants buzz in on their
  //       devices over *WebSockets*],
  //     [Synchronised game state between clients and the host with shared types and the
  //       *observer pattern*],
  //   ),
  // )

  // #project(
  //   "RecipeReady",
  //   "https://github.com/vincentjguo/recipeready-server",
  //   "Flutter, Selenium, FastAPI, Android",
  // )
  // - Developed a *Flutter app* to generate recipes based on ingredients and filters
  //   through a FastAPI server
  // - Scraped thousands of websites for recipes to build a database with a robust
  //   *many-to-many tag system*
  // - Aggregated common ingredients heuristically to build a shopping list and a meal
  // plan for each week

  // #project("Arch Linux Server", "Linux, Docker, nginx, systemd", demo_link: "https://eggworld.me")
  // - Created a *self-hosted CI/CD pipeline* with *Gitea* to automatically deploy
  //   personal projects behind *nginx*
  // - Containerised services with *Docker* and *systemd* to simplify deployment and
  //   management
]